
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "matrix.h"

int TMatrix::lenOfPassword (const char *p)
{
	register int lenOfPasswordString=0;

	while (*p)
	{
		switch (*p)
		{
			case '(':
				while ( *p++ != ')' )
				;
				lenOfPasswordString++;
				break;
			case '"':
				p+=2;
				lenOfPasswordString++;
				break;
			default:
				p++;
				lenOfPasswordString++;
				break;

		}
	}

	return lenOfPasswordString;
}

int TMatrix::isWildString(const char *p)
{
	return ( * ( p + strlen (p) - 1 ) == '*' );
}

char * TMatrix::getPos ( int pos, const char * p, char *d )
{
	register int i=0;

	while (i < pos && *p)
	{
		switch (*p)
		{
			case '(':
				while ( *p++ != ')' )
				;
				i++;
				break;
			case '"':
				p++;
			default:
				p++;
				i++;
				break;
		}
	}

	i=0;

	const char *t=p;

	switch (*t)
	{
		case '(':
			while ( *t++ != ')' )
								i++;
			break;
		case '"':
			t++;
			i++;
		default:
			t++;
			i++;
			break;
	}


	strncpy(d,p,i);

    *(d+i)='\0';

    return (d);
}

char TMatrix::random_key (int false_opt)
{
    char ch;

    while(TRUE)
    {
		ch = (char) random(122);
		if ((false_opt & _IS_DIG ) && isdigit(ch)) break;
		if ((false_opt & _IS_UPP ) && isupper(ch)) break;
		if ((false_opt & _IS_LOW ) && islower(ch)) break;
		if ((false_opt & _IS_PUN ) && ispunct(ch)) break;
		if ((false_opt & _IS_HEX ) && isxdigit(ch)) break;

		if ((false_opt == (_IS_UPP | _IS_LOW) ) && isalpha(ch)) break;
		if ((false_opt == (_IS_DIG|_IS_UPP|_IS_LOW)) && isalnum(ch)) break;
	}

	return(ch);
}


char TMatrix::getCh ( char *string )
{
    BOOL skip = FALSE;

    if ( strpbrk ( string, "*@#+?<>$\"()") )
	{
		while( *string && ! skip )
		{
			switch ( *string )
			{
				case '$':
				case '*':
					return ( random_key (0x7f) );
				case '@':
					return ( random_key (_IS_UPP | _IS_LOW) );
				case '#':
					return ( random_key (_IS_DIG) );
				case '+':
					return ( random_key (_IS_DIG|_IS_UPP|_IS_LOW) );
				case '?':
					return ( random_key (_IS_HEX) );
				case '<':
					return ( random_key (_IS_LOW) );
				case '>':
					return ( random_key (_IS_UPP) );
				case '(':
				{
					string++;

					char ch=random(strlen(string));

					return *(string+ch);
				}
				case '"':
					return (*(++string));

			}
			string++;
		}
	}

	return (*string);
}

TMatrix::TMatrix(int len, const char* str)
{
    wild[0]     =   '\0';
    num_digit   =   len;
    password    =   str;
}

BOOL TMatrix::makeReplay(const char* challenge)
{
    for (int j=0;j<num_digit;j++)
    {
        const char *d=challenge;

        if(!*challenge)
            break;

        while(!isdigit(*challenge))
        {
            if(!*challenge)
                break;

            d=++challenge;
        }

        while(isdigit(*challenge))
                         challenge++;

        if(atoi(d) > lenOfPassword(password.c_str()))
             return FALSE;

        if ( isWildString(password.c_str()) &&
            atoi(d) > lenOfPassword(password.c_str()) )
                                     replay += random_key();
        else
        {
            getPos(atoi(d)-1,password.c_str(),wild);
            replay += getCh(wild);
        }
     }
     return TRUE;
}


